#ifndef _MCAMERA_H_
#define _MCAMERA_H_

// trieda pre pracu s OpenGL kamerou
class mCamera {
public:
 mCamera();          // konstruktor
 virtual ~mCamera(); // destruktor

 // reset parametrov kamery
 void cam_reset(void);
 // reset casu
 void cam_resettime(void);
 // reinicializacia kamery
 void cam_reinit(GLfloat w,GLfloat h);
 // nastavenie perspektivneho premietania
 void cam_SetPerspective(void);
 // rotacia kamery
 void cam_rotate_xy(GLfloat x,GLfloat y);
 void cam_rotate_z(GLfloat z);
 // posun kamery
 void cam_move(void);
 // aktualizacia nastaveni kamery
 void cam_update(void);
 // zap/vyp detekcie kolizii
 void CollisionOnOff(void);
 // cas medzi vykreslenim 2 snimkov
 GLfloat GetCameraTime(void);

 GLfloat scr_w,scr_h; // sirka, vyska okna

 GLfloat matrix[16];                             // matica kamery
 GLfloat posx,posy,posz;                         // poloha
 GLfloat oldx,oldy,oldz;                         // povodna poloha
 GLfloat targetx,targety,targetz;                // smer

 // indikatory pre vykonavanie definovanych posunov kamery
 GLfloat goForward,goBack,goUp,goDown,goRight,goLeft;
 GLubyte goJump,goFast;

 GLubyte isFire1; // strelba1 (lave tlacidlo mysi)
 GLubyte isFire2; // strelba2 (prave tlacidlo mysi)

 GLubyte movetype; // typ pohybu

 GLfloat AVATAR_eye;  // vyska oci AVATARa - potrebne pre vypocet kolizii
 GLfloat AVATAR_wide; // sirka AVATARa - potrebne pre vypocet kolizii

 GLfloat ogl_fps; // pocitadlo FPS (snimky za sekundu)

 // indikator zap/vyp dektekcie kolizii
 GLubyte collision_onoff;
 // indikator vyskytu kolizie
 GLubyte is_collision;
private:
 GLuint t_a,t_b; // pomocne premenne

 GLfloat movx,movy,movz;                // posun kamery
 GLfloat angx,angy,angz,rotx,roty,rotz; // otocenie, rotacia
 GLfloat speed,slide,alt;               // rychlost, bocny pohyb, zmena vysky
 GLfloat fspeed,fslide,falt;            // pre rychlejsi pohyb
 GLfloat acceleration,gravity;          // zrychlenie, gravitacne zrychlenie
 GLfloat viewnear,viewfar;              // minimalny a maximalny dohlad
 GLfloat FOV;                           // uhol pohladu
 GLfloat JumpPower;                     // sila skoku

 GLfloat movx_factor,movy_factor,movz_factor; // konstanty pre upravu rychlosti posunu
 GLfloat rotx_factor,roty_factor,rotz_factor; // konstanty pre upravu rychlosti rotacie

 // ulozenie stareho a noveho casoveho okamihu (ms)
 GLuint actTime,oldTime;
 // cas vykreslenia sceny
 GLfloat difTime;
 // cas posobenia gravitacie
 GLfloat gravityTime;
 // pocitadlo pre FPS (pocet snimkov)
 GLfloat ogl_frames;
};

#endif
