#ifndef _MCOLDCATHODE_H_
#define _MCOLDCATHODE_H_

#include "mShader.h"

// trieda premennych a funkcii pre pracu s neonovym svietidlom
class mColdCathode {
public:
 mColdCathode();          // konstruktor
 virtual ~mColdCathode(); // destruktor

 // inicializacia neonoveho svietidla
 void init(const tVec4 C,const float R);
 // vykreslenie neonoveho svietidla
 void render(const tVec3 C);

 tVec3 pos[2]; // poloha dvoch koncov neonoveho svietidla (trubice)
 tVec4 color;  // farba neonoveho svietidla
private:
 GLfloat radius; // polomer neonoveho svietidla

 mShader lamp_vp; // VertexProgram pre LampShader
 mShader lamp_fp; // FragmentProgram pre LampShader

 m3dmath mm;   // pre vykonavanie matematickych vypoctov
 tVec3 A[3],B; // pomocne vektory
 mat16 M;      // pomocna matica
};

#endif
