#ifndef _MSHADER_H_
#define _MSHADER_H_

#include "m3dmath.h"

// trieda premennych a funkcii pre pracu so shaderom
// jedna sa o VertexShaderProgram alebo FragmentShaderProgram
class mShader {
public:
 mShader();          // konstruktor
 virtual ~mShader(); // destruktor

 // test ci karta podporuje rozsirenie
 int CheckExtension(const char *ext_name);
 // inicializacia rozsireni
 int Ext_init();
 // nahratie ShaderProgramu
 int PRGload(const char *src);

 void PRGenable();  // zapnutie ShaderProgramu
 void PRGdisable(); // vypnutie ShaderProgramu
 void PRGbind();    // pripojenie ShaderProgramu

 // vlozenie Environment parametra do ShaderProgramu
 void PRGenv_param(GLuint index,const tVec4 &p);
 // vlozenie Local parametra do ShaderProgramu
 void PRGlocal_param(GLuint index,const tVec4 &p);
 // vlozenie Named parametra do ShaderProgramu
 void PRGnamed_param(const char *name,const tVec4 &p);

 // udajovy typ pre popis volanych funkcii - glTextCoord
 PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB;
 // urcenie texturovacej jednotky, ktora prijme info o texture
 PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;

 // pocet texturovacich jednotiek Texel-Pipelines
 GLint maxTexelUnits;

 GLuint target; // objekt ShaderProgramu
 GLuint id;     // identifikator objektu ShaderProgramu

 int error; // priznak chyby
private:

};

#endif
